# Flutter coverage util

### Описание

Пакет создан для сбора корректных данных о покрытии проекта тестами.

При расчете покрытия [Codecov](https://about.codecov.io/) анализирует только те файлы, которые
импортированы или экспортированы в файлы, которые мы тестируем. Поэтому может случиться ситуация при
которой не будет протестирован какой-то функционал, но при этом это ни как не отразится на проценте
покрытия, тем самым мы получим не корректные данные.

Этот пакет собирает все файлы которые заканчиваются на .dart в один файл и добавляет этот файл в директорию test.

**Исключения:**
- файлы содержащие в себе функцию main; 
- файлы, которые являются частью другого файла(part of'');
- файлы, которые содержат экспорт других файлов;
- сгенерированных файлов, которые содержать в названии .g.;

**Примечание:** файлы, сгенерированные freezed по умолчанию при расчете покрытия тестами не учитываются.

Если у вас есть файлы, которые по каким-то причинам не надо учитывать, можете добавить в файл:
```dart
// coverage:ignore-file
```


Затем запускает команду flutter
test --coverage и конвертирует полученный lcov файл в html формат, который вы самостоятельно можете
открыть и посмотреть процент покрытия вашего проекта тестами. 

Для того что бы конвертация прошла успешна у вас должен быть установлен LCOV, если у вас установлен
brew можно воспользоваться командой:
```dart
brew install lcov
```

Для запуска утилиты сначала запустите команду:
```dart
flutter pub global activate coverage_util
```

Затем: 
```dart
flutter pub global run coverage_util
```
